// NS20Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "NS20.h"
//#include <afxsock.h>
#include "NS20Socket.h"
#include "NS20Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//CNS20Socket *m_ns20Socket;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNS20Dlg dialog

CNS20Dlg::CNS20Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNS20Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNS20Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNS20Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNS20Dlg)
	DDX_Control(pDX, IDC_EDIT_COUNT, m_editCount);
	DDX_Control(pDX, IDC_EDIT_STATE, m_editState);
	DDX_Control(pDX, IDC_EDIT_SENDINFO, m_editSendInfo);
	DDX_Control(pDX, IDC_EDIT_RECVINFO, m_editRecvInfo);
	DDX_Control(pDX, IDC_EDIT_PORT, m_editPort);
	DDX_Control(pDX, IDC_EDIT_NUM, m_editNum);
	DDX_Control(pDX, IDC_EDIT_IP, m_editIP);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNS20Dlg, CDialog)
	//{{AFX_MSG_MAP(CNS20Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_SENDINFO, OnButtonSendInfo)
	ON_EN_CHANGE(IDC_EDIT_SENDINFO, OnChangeEditSendinfo)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNS20Dlg message handlers

BOOL CNS20Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//öԻָ
	m_ns20Socket.m_hDlgWnd=this;

	//趨Ĭֵ
	m_editIP.SetWindowText("192.168.1.24");	
	m_editPort.SetWindowText("1234");
	m_editNum.SetWindowText("13521000329");
	m_editSendInfo.SetWindowText("");
	m_editState.SetWindowText("OFF");
	m_editCount.SetWindowText("2");
	GetDlgItem(IDC_BUTTON_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_CLOSE)->EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNS20Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNS20Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNS20Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//
void CNS20Dlg::OnButtonStart() 
{
	TCHAR hostIP[20];	//IPַ
	TCHAR hostPort[10];	//˿ںţַ
	UINT nHostPort;	//˿ں

	//ıȡIPַͶ˿ں
	m_editIP.GetWindowText(hostIP,20);
	m_editPort.GetWindowText(hostPort,10);
	nHostPort=atoi(hostPort);

	//ѾSocketر֮
	m_ns20Socket.Close();
	//Socket
	if(!m_ns20Socket.Create())
	{
		MessageBox("Create Socket Error!");
		return;
	}
	//ӡ첽ʽǷӳɹOnConnectж
	m_ns20Socket.Connect(hostIP,nHostPort);

	GetDlgItem(IDC_BUTTON_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CLOSE)->EnableWindow(TRUE);
}

//
void CNS20Dlg::OnButtonSendInfo() 
{
	UINT numLen;	//Է볤
	TCHAR numLenChar[5]={NULL};	//볤(ַ)
	wchar_t sendUnicode[200]={NULL};	//Unicodeַ
	CString typeStr,numLenStr,sendNum,sendInfo,sendStr;	//ֱ͡Է볤ȡԷ롢ݣַ
	
	//
	typeStr="0";	//0ʾͶ
	//Է
	m_editNum.GetWindowText(sendNum);
	//볤
	numLen=m_editNum.GetWindowTextLength();
	_itoa(numLen,numLenChar,10);
	numLenStr=numLenChar;
	//
	m_editSendInfo.GetWindowText(sendInfo);
/*	if (m_editSendInfo.GetWindowTextLength()>140)
	{
		AfxMessageBox("ַ̫!");
		return;
	}
*/
	//Ҫ͵ַ
	sendStr=typeStr+numLenStr+sendNum+sendInfo;
	//ֽڱUnicodeַ1ı"31""3100"
	MultiByteToWideChar(CP_ACP,0,sendStr.GetBuffer(200),-1,sendUnicode,sendStr.GetLength());
	
	//
	int nSend;
	nSend=wcslen(sendUnicode);
	nSend=m_ns20Socket.Send(sendUnicode,2*wcslen(sendUnicode));
	if (nSend<=0) 
	{
		MessageBox("ʧܣ!");
	}
}


void CNS20Dlg::OnChangeEditSendinfo() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here

	//Ҫ͵Ķŵֽ
	UINT nCount;
	TCHAR cCount[5]={NULL};
	nCount=m_editSendInfo.GetWindowTextLength();
	itoa(nCount,cCount,10);
	m_editCount.SetWindowText(cCount);
}


void CNS20Dlg::OnButtonClose() 
{
	//ѾSocketر֮
	m_ns20Socket.Close();
	//رպӱ־Ϊ"OFF"
	m_editState.SetWindowText("OFF");

	GetDlgItem(IDC_BUTTON_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_CLOSE)->EnableWindow(FALSE);
}
